/*
 * sleipnir favorite duplicate killer
 *  Version 1.00
 *   by Murachue
 * 
 * ** ₭ **
 * zzA]ڂ̓IWî܂܁B
 * ύXĔzzƂ̓IWȉꏊƂɂIWiɓ悤ɂĂˁB
 * oCizzƂ̂͂悵Ă(ςȓ삳ċ獢̂)
 * 
 * \[XĂ܂(LDM;)
 */

/*
 * Borland C++ Compiler 5.5ŃRpCmF
 * Windows XP SP1œmFς
 */

/**********************************************************************/

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include <borutil.h>	/* for basename() */

/**********************************************************************/

#define VERSION "1.00"

/*
#define DEBUG
*/

#define STR_MAX 1025	/* "String..."(1024byte) '\0' */
#define MAX_FILENAMELENGTH 259	/* "C:" "\long\file\name\...\path"(256byte) '\0' */

/* sfv-item type */
#define ITEM_URL 1
#define ITEM_FOLDER 2

/* Options flag */
#define OPTION_VERBOSE 1
#define OPTION_DONTKILL 2
#define OPTION_PRINTITEMS 4
#define OPTION_LISTUP 8
#define OPTION_VERSION 16

/**********************************************************************/

typedef struct _tag_SFVITEM{
	char title[STR_MAX];
	char comment[STR_MAX];
	int useflag;
	struct{
		int one;
		int two;
		int three;
		int four;
	}unknown;
	struct{
		int javascript;
		int javaapplet;
		int activexrun;
		int activexdl;
		int picture;
		int sound;
		int video;
		int navigatelock;
		int autorefresh;
	}flag;
	struct{
		char url[STR_MAX];
		int visited;
	}url;
	struct{
		int color;
/* \ł́A
		int childs;
*/
	}folder;

	struct _tag_SFVITEM *child;
	struct _tag_SFVITEM *next;
}SFVITEM;

typedef struct _tag_SFVITEMMINI{
	char url[STR_MAX];
	struct _tag_SFVITEMMINI *next;
}SFVITEMMINI;

typedef struct _tag_ITEMS{
	int total;
	int folders;
	int urls;
}ITEMS;

const char *FCOLOR[]={
	"ftHg",
	"",
	"",
	"",
	"F",
	"",
	"",
	"DF",
	"",
};

/**********************************************************************/

int mode;

/**********************************************************************/

SFVITEM *new_sfvitem(){	/* V̈m */
	SFVITEM *item;

	if((item = (SFVITEM *)malloc(sizeof(SFVITEM))) == NULL){
		printf("Error: new_sfvitem: can't malloc\n");
		return NULL;
	}

	item->child = NULL;
	item->next = NULL;

	return item;
}

void free_sfvitem(SFVITEM *item){	/*  EĂ낤 zggMX */
	if(item->child != NULL)
		free_sfvitem(item->child);
	if(item->next != NULL)
		free_sfvitem(item->next);
	free(item);
}

SFVITEM *readitemfromsfv(FILE *fp,int readtype){	/* Root擾ۂreadtype0Ƃ邱 */
	SFVITEM *item;
	long count;
	long length;
	char type;

	if((item=new_sfvitem())==NULL){
		printf("Error: readitemfromsfv: can't new sfvitem\n");
		return NULL;
	}

	if(readtype)
		fread(&type,sizeof(char),1,fp);
	else
		type=ITEM_FOLDER;

	fread(&length,sizeof(long),1,fp);
	fread(item->title,sizeof(char),length,fp);
	item->title[length]=NULL;
	fread(&length,sizeof(long),1,fp);
	fread(item->comment,sizeof(char),length,fp);
	item->comment[length]=NULL;

	fread(&item->unknown.one,sizeof(long),1,fp);
	fread(&item->unknown.two,sizeof(long),1,fp);
	fread(&item->unknown.three,sizeof(long),1,fp);

	fread(&item->useflag,sizeof(long),1,fp);
	fread(&item->flag.javascript,sizeof(long),1,fp);
	fread(&item->flag.javaapplet,sizeof(long),1,fp);
	fread(&item->flag.activexrun,sizeof(long),1,fp);
	fread(&item->flag.activexdl,sizeof(long),1,fp);
	fread(&item->flag.picture,sizeof(long),1,fp);
	fread(&item->flag.sound,sizeof(long),1,fp);
	fread(&item->flag.video,sizeof(long),1,fp);
	fread(&item->flag.navigatelock,sizeof(long),1,fp);
	fread(&item->flag.autorefresh,sizeof(long),1,fp);

	fread(&item->unknown.four,sizeof(long),1,fp);

	switch(type){
	case ITEM_URL:
		fread(&length,sizeof(long),1,fp);
		fread(item->url.url,sizeof(char),length,fp);
		item->url.url[length]=NULL;
		fread(&item->url.visited,sizeof(long),1,fp);
		break;
	case ITEM_FOLDER:
		fread(&item->folder.color,sizeof(long),1,fp);
		fread(&count,sizeof(long),1,fp);
		break;
	default:
		printf("Error: readitemfromsfv: illegal type\n");
		free(item);	/* FIXME */
		return NULL;
	}

	if(type == ITEM_FOLDER){
		SFVITEM *newitem,*previtem;

		previtem=NULL;
		for(long i=0;i<count;i++){
			newitem=readitemfromsfv(fp,1);
			if(previtem==NULL)
				item->child=newitem;	/* First Item */
			else
				previtem->next=newitem;	/* Second or later Item */
			previtem=newitem;
		}
	}
	return item;
}

void savetosfv(FILE *fp,SFVITEM *item,int writetype){	/* Rootۑۂwritetype0Ƃ邱 */
	long count;
	long length;
	char type;
	SFVITEM *newitem=item->child;

	if(writetype){
		if(item->child == NULL)
			type=ITEM_URL;
		else
			type=ITEM_FOLDER;
		fwrite(&type,sizeof(char),1,fp);
	}else
		type=ITEM_FOLDER;

	length=strlen(item->title);
	fwrite(&length,sizeof(long),1,fp);
	fwrite(item->title,sizeof(char),length,fp);
	length=strlen(item->comment);
	fwrite(&length,sizeof(long),1,fp);
	fwrite(item->comment,sizeof(char),length,fp);

	fwrite(&item->unknown.one,sizeof(long),1,fp);
	fwrite(&item->unknown.two,sizeof(long),1,fp);
	fwrite(&item->unknown.three,sizeof(long),1,fp);

	fwrite(&item->useflag,sizeof(long),1,fp);
	fwrite(&item->flag.javascript,sizeof(long),1,fp);
	fwrite(&item->flag.javaapplet,sizeof(long),1,fp);
	fwrite(&item->flag.activexrun,sizeof(long),1,fp);
	fwrite(&item->flag.activexdl,sizeof(long),1,fp);
	fwrite(&item->flag.picture,sizeof(long),1,fp);
	fwrite(&item->flag.sound,sizeof(long),1,fp);
	fwrite(&item->flag.video,sizeof(long),1,fp);
	fwrite(&item->flag.navigatelock,sizeof(long),1,fp);
	fwrite(&item->flag.autorefresh,sizeof(long),1,fp);

	fwrite(&item->unknown.four,sizeof(long),1,fp);

	switch(type){
	case ITEM_URL:
		length=strlen(item->url.url);
		fwrite(&length,sizeof(long),1,fp);
		fwrite(item->url.url,sizeof(char),length,fp);
		fwrite(&item->url.visited,sizeof(long),1,fp);
		break;
	case ITEM_FOLDER:
		fwrite(&item->folder.color,sizeof(long),1,fp);
		for(count=0;newitem != NULL;count++)
			newitem=newitem->next;
		fwrite(&count,sizeof(long),1,fp);
		break;
	default:
		printf("Error: savetosfv: Internal error: illegal type\n");
		return;
	}

	if(type == ITEM_FOLDER){
		newitem=item->child;
		for(;;){
			if(newitem == NULL)
				break;
			savetosfv(fp,newitem,1);
			newitem=newitem->next;
		}
	}
	return;
}

/**********************************************************************/

SFVITEMMINI *new_sfvitemmini(char *str){
	SFVITEMMINI *item;

	if((item = (SFVITEMMINI *)malloc(sizeof(SFVITEMMINI))) == NULL){
		printf("Error: new_sfvitemmini: can't malloc\n");
		return NULL;
	}

	item->next = NULL;
	if(str == NULL)
		item->url[0] = NULL;
	else
		strcpy(item->url,str);

	return item;
}

void free_sfvitemmini(SFVITEMMINI *item){
	if(item->next != NULL)
		free_sfvitemmini(item->next);
	free(item);
}

/**********************************************************************/

void spacer(int num){
	int i=0;

	for(;i<num;i++)
		printf(" ");
}

void listup(SFVITEM *item,int nestlevel){
	while(1){
		spacer(nestlevel);
		printf("Title:%s\n",item->title);
		spacer(nestlevel);
		printf("Comment:%s\n",item->comment);
		spacer(nestlevel);
		printf("Setting:");
		if(!item->useflag)
			printf("(");
		if(item->flag.javascript)
			printf("J");
		else
			printf("-");
		if(item->flag.javaapplet)
			printf("A");
		else
			printf("-");
		if(item->flag.activexrun)
			printf("X");
		else
			printf("-");
		if(item->flag.activexdl)
			printf("D");
		else
			printf("-");
		if(item->flag.picture)
			printf("P");
		else
			printf("-");
		if(item->flag.sound)
			printf("S");
		else
			printf("-");
		if(item->flag.video)
			printf("V");
		else
			printf("-");
		if(item->flag.navigatelock)
			printf("L");
		else
			printf("-");
		printf(",%d",item->flag.autorefresh);
		if(!item->useflag)
			printf(")");
		printf("\n");
		if(item->child != NULL){
			spacer(nestlevel);
			printf("Color:%s\n",FCOLOR[item->folder.color]);
#ifdef DEBUG
			printf(">\n");
#endif
			listup(item->child,nestlevel+1);
		}else{
			spacer(nestlevel);
			printf("URL:%s\n",item->url.url);
			spacer(nestlevel);
			printf("Visited:%d\n",item->url.visited);
		}
		if(item->next == NULL)
			break;

		item=item->next;
		printf("\n");
	}
#ifdef DEBUG
	printf("<\n");
#endif
}

int searchstack(SFVITEMMINI *stack,char *str){
	SFVITEMMINI *current=stack;
	while(1){
		if(current == NULL)
			return 0;
		if(!strcmp(current->url,str))
			return 1;
		current=current->next;
	}
}

SFVITEMMINI *addstack(SFVITEMMINI *stack,char *str){
	SFVITEMMINI *current=stack,*top=stack;
	if(stack == NULL){
		if((top=new_sfvitemmini(str))==NULL){
			printf("Error: addstack: new_sfvitemmini failed\n");
			return NULL;
		}
		return top;
	}
	while(1){
		if(current->next == NULL){
			if((current->next=new_sfvitemmini(str))==NULL){
				printf("Error: addstack: new_sfvitemmini failed\n");
				return NULL;
			}
			return top;
		}
		current=current->next;
	}
}
SFVITEMMINI *stack=NULL;

/* ł킩Ȃ */
SFVITEM *killdup_sub(SFVITEM *item,int *deleted){
	SFVITEM *previtem,*top=item;
	SFVITEM tmp;

#ifdef DEBUG
	printf("Killing[%s]\n",item->title);
#endif
	tmp.next=top;
	tmp.child=NULL;
	previtem=&tmp;
	while(1){
		if(item == NULL)
			break;
		if(item->child != NULL){
#ifdef DEBUG
			printf("Killing[%s]\n",item->title);
#endif
			item->child=killdup_sub(item->child,deleted);
		}else{
			if(searchstack(stack,item->url.url)){
				SFVITEM *next=item->next;

				if(item->next == NULL)
					previtem->next = NULL;
				else
					previtem->next=item->next;
				if(mode & OPTION_VERBOSE)
					printf("Dup.Deleted %s (%s)\n",item->title,item->url.url);
				free(item);
				(*deleted)++;
#ifdef DEBUG
				printf("%d\n",*deleted);
#endif

				item=next;
				continue;
			}else{
				stack=addstack(stack,item->url.url);
#ifdef DEBUG
				printf("Adding %s\n",item->url.url);
#endif
			}
		}
		if(item->next == NULL)
			break;

		previtem=item;
		item=item->next;
	}
#ifdef DEBUG
	printf("\n");
#endif

	return tmp.next;
}

SFVITEM *killdup(SFVITEM *item){
	int deleted=0;

	item=killdup_sub(item,&deleted);

	printf("Deleted %d items.\n",deleted);
	if(stack != NULL){
		printf("Freeing stack...");
		free_sfvitemmini(stack);
		stack=NULL;
		printf("Done\n");
	}

	return(item);
}

void countitems_sub(ITEMS *items,SFVITEM *item){
	for(;;){
		if(item == NULL)
			break;
		if(item->child == NULL){
			items->total++;
			items->urls++;
		}else{
			items->total++;
			items->folders++;
			countitems_sub(items,item->child);
		}
		item=item->next;
	}
}

void countitems(ITEMS *items,SFVITEM *item){
	items->total=0;
	items->folders=0;
	items->urls=0;

	countitems_sub(items,item);
}

void showversion(){
	printf("sfdKiller Ver." VERSION " by Murachue\n");
	printf("Built at %s %s\n",__DATE__,__TIME__);
	printf("\n");
}

int main(int argc,char *argv[]){
	FILE *fp;
	char head[11];
	short ver;
	SFVITEM *root[2];
	SFVITEM *duplist,*duplistend;
	ITEMS before,after;
	char srcfile[MAX_FILENAMELENGTH];
	char dstfile[MAX_FILENAMELENGTH];
	int i,j,fcnt,parsearg;

	srcfile[0]=NULL;
	dstfile[0]=NULL;

	for(i=1,fcnt=0,parsearg=1;i<argc;i++){
#ifdef DEBUG
		printf("%d:%s\n",i,argv[i]);
#endif
		if(parsearg && (argv[i][0] == '-' || argv[i][0] == '/')){
			for(j=1;argv[i][j] != NULL;j++){
				switch(argv[i][j]){
				case 'v':
					mode |= OPTION_VERBOSE;
					break;
				case 'i':
					mode |= OPTION_PRINTITEMS;
					break;
				case 'n':
					mode |= OPTION_DONTKILL;
					break;
				case 'l':
					mode |= OPTION_LISTUP;
					mode |= OPTION_DONTKILL;	/* ListupKill͕KvȂ */
					break;
				case 'V':
					mode |= OPTION_VERSION;
					break;
				case '-':
					if(j == 1 && argv[i][2] == NULL){
						parsearg=0;
						continue;
					}
				default:
					printf("Unknown argument: %c\n",argv[i][j]);
				}
			}
		}else{
			if(fcnt == 0){
				strcpy(srcfile,argv[i]);
				fcnt++;
				continue;
			}
			if(fcnt == 1){
				strcpy(dstfile,argv[i]);
				fcnt++;
				continue;
			}
			printf("Too many file arguments!");
			return 1;
		}
	}

	if(mode & OPTION_VERSION){
		showversion();
		return 0;
	}

	if(!strcmp(srcfile,"") || (!(mode & OPTION_DONTKILL) && !strcmp(dstfile,""))){
		printf("Usage: %s [options] srcfile [dstfile]\n",basename(argv[0]));
		printf("Options\n");
		printf(" -i: Print items - before,after\n");
		printf(" -n: Don't kill - useful for counting items(with -i),don't output.\n");
		printf(" -l: Listup - for DEBUG and ...(Automatically switch on -n)\n");
		printf(" -v: Verbose - show killed items\n");
		printf(" -V: Show version.");
		return 0;
	}

	if((fp=fopen(srcfile,"rb"))==NULL){
		printf("%s: Can't open input file\n",basename(argv[0]));
		return -1;
	}

	fread(head,sizeof(char),11,fp);
	if(strncmp(head,"SFV-FORMAT\x1A",11)){
		printf("ERROR: It isn't SFV file!\n");
		goto error;
	}
	fread(&ver,sizeof(short),1,fp);
	if(ver != 101){
		printf("ERROR: only support SFV1.01...sorry.\n");
		goto error;
	}

	showversion();

	printf("Reading LINKS...");
	root[0]=readitemfromsfv(fp,0);
	printf("Done\n");
	printf("Reading Favorite...");
	root[1]=readitemfromsfv(fp,0);
	printf("Done\n");
	printf("Linking tree LINKS->Favorite...");
	root[0]->next=root[1];
	printf("Done\n");

	fclose(fp);

	if(mode & OPTION_PRINTITEMS && !(mode & OPTION_DONTKILL)){
		printf("Counting items...");
		countitems(&before,root[0]);
		printf("Done\n");
	}

	if(mode & OPTION_LISTUP)
		listup(root[0],0);

	if(!(mode & OPTION_DONTKILL)){
		/* Kill Dups */
		printf("Killing duplicating items...\n");
		killdup(root[0]);
		printf("Done\n");
	}

	if(mode & OPTION_PRINTITEMS){
		printf("Counting items...");
		countitems(&after,root[0]);
		printf("Done\n");
	}

	if(mode & OPTION_PRINTITEMS){
		if(mode & OPTION_DONTKILL){
			printf("%d items, %d folder, %d urls.\n",after.total,after.folders,after.urls);
		}else{
			printf("\n");
			printf("Before: %d items, %d folder, %d urls.\n",before.total,before.folders,before.urls);
			printf("After: %d items, %d folder, %d urls.\n",after.total,after.folders,after.urls);
			printf("\n");
		}
	}

	/* ListUp */
	/* listup(root[0],0); */

	printf("Unlinking tree LINKS->Favorite...");
	root[0]->next=NULL;
	printf("Done\n");

	if(!(mode & OPTION_DONTKILL)){
		/* Export start */
		printf("Exporting!\n");
		if((fp=fopen(dstfile,"wb"))==NULL){
			printf("ERROR: Can't open output file!\n");
			return -1;
		}

		printf("Writing SFV Header...");
		fwrite("SFV-FORMAT\x1A",sizeof(char),11,fp);
		ver=101;
		fwrite(&ver,sizeof(short),1,fp);
		printf("Done\n");

		/* Export Items */
		printf("Exporting LINKS...");
		savetosfv(fp,root[0],0);
		printf("Done\n");
		printf("Exporting Favorite...");
		savetosfv(fp,root[1],0);
		printf("Done\n");

		printf("Export was completed!\n");
	}

	printf("Freeing LINKS...");
	free_sfvitem(root[0]);
	printf("Done\n");
	printf("Freeing Favorite...");
	free_sfvitem(root[1]);
	printf("Done\n");

	return 0;
error:
	printf("File close...");
	fclose(fp);
	printf("OK\n");
	return 1;
}
